from fastapi import FastAPI
from pydantic import BaseModel
import pickle
import json

app = FastAPI()

class ModelInput(BaseModel):
    Grade: int
    Marks: int
    Time_Spent_q1: int
    Time_Spent_q2: int
    Time_Spent_q3: int
    Time_Spent_q4: int
    Time_Spent_q5: int
    Subject_English: bool
    Subject_EnvironmentalScience: bool
    Subject_Maths: bool

# Loading the saved model
predictor_model = pickle.load(open('predictor.pickle', 'rb'))

@app.post('/knowledgelevel_prediction')
async def knowledgelevel_prediction(input_parameters: ModelInput):
    input_data = input_parameters.dict()

    grade = input_data['Grade']
    marks = input_data['Marks']
    ts1 = input_data['Time_Spent_q1']
    ts2 = input_data['Time_Spent_q2']
    ts3 = input_data['Time_Spent_q3']
    ts4 = input_data['Time_Spent_q4']
    ts5 = input_data['Time_Spent_q5']
    english = input_data['Subject_English']
    escience = input_data['Subject_EnvironmentalScience']
    maths = input_data['Subject_Maths']

    input_list = [grade, marks, ts1, ts2, ts3, ts4, ts5, english, escience, maths]

    prediction = predictor_model.predict([input_list])

    # You can return the prediction as a response
    return {'knowledge_level': prediction[0]}