import React,{useState, useContext} from "react";
import axios from "axios";
import { useNavigate } from 'react-router-dom';
import { Button, Form, Row, Col } from "react-bootstrap";
import Card from "react-bootstrap/Card";

function StaffRegister() {


    const [validated, setValidated] = useState(false);
    const navigate = useNavigate();

    const [question, setQuestion] = useState("");
    const [option1, setoption1] = useState("");
    const [option2, setoption2] = useState("");
    const [option3, setoption3] = useState("");
    const [answer, setanswer] = useState("");
    const [subject, setSubject] = useState("");
    const [grade, setgrade] = useState("");
  
    const handleSubmit = (event) => {
        
      const form = event.currentTarget;
      if(form.checkValidity()==true){
        event.preventDefault();
        event.stopPropagation();
        sendData();
      }
      else{
        if (form.checkValidity() == false) {
            event.preventDefault();
            event.stopPropagation();
        }
        
        setValidated(true); 
      }
      
    };

    const sendData = (e) => {

        const newQuestion = {
            question,
            option1,
            option2,
            option3,
            answer,
            subject,
            grade
        }

        axios.post("https://elearning-server.herokuapp.com/question/new", newQuestion).then((res)=>{
            alert(res.data);
            window.location.assign("/");
        }).catch((err)=>{
            alert(err);
        })
    }
  
    return (
        <div className="container mt-5">
            <br/><br/>
            <Card style={{ width: '60rem', margin:"auto" }}>
            <Card.Body>
                <Card.Title>Add New Question</Card.Title>
                <Form noValidate validated={validated} onSubmit={handleSubmit}>
                    <Row className="mb-3">
                    <Form.Group as={Row} md="5" controlId="validationCustom04">
                        <Form.Label>Question</Form.Label>
                        <Form.Control type="text" 
                        onChange={(e) => {
                            setQuestion(e.target.value);
                        }}
                        required />
                        <Form.Control.Feedback type="invalid">
                        Please provide a valid Question.
                        </Form.Control.Feedback>
                    </Form.Group>
                    <Form.Group as={Row} md="5" controlId="validationCustom04">
                        <Form.Label>Option 1</Form.Label>
                        <Form.Control type="text" 
                        onChange={(e) => {
                            setoption1(e.target.value);
                        }}
                        required />
                        <Form.Control.Feedback type="invalid">
                        Please provide the first option.
                        </Form.Control.Feedback>
                    </Form.Group>
                    <Form.Group as={Row} md="5" controlId="validationCustom04">
                        <Form.Label>Option 2</Form.Label>
                        <Form.Control type="text" 
                        onChange={(e) => {
                            setoption2(e.target.value);
                        }}
                        required />
                        <Form.Control.Feedback type="invalid">
                        Please provide the second option.
                        </Form.Control.Feedback>
                    </Form.Group>
                    <Form.Group as={Row} md="5" controlId="validationCustom04">
                        <Form.Label>Option 3</Form.Label>
                        <Form.Control type="text" 
                        onChange={(e) => {
                            setoption3(e.target.value);
                        }}
                        required />
                        <Form.Control.Feedback type="invalid">
                        Please provide the third option.
                        </Form.Control.Feedback>
                    </Form.Group>
                    <Form.Group as={Row} md="5" controlId="validationCustom04">
                        <Form.Label>Answer</Form.Label>
                        <Form.Control type="text" 
                        onChange={(e) => {
                            setanswer(e.target.value);
                        }}
                        required />
                        <Form.Control.Feedback type="invalid">
                        Please provide the correct answer.
                        </Form.Control.Feedback>
                    </Form.Group>
                    <Form.Group as={Row} md="2" controlId="validationCustom04">
                        <Form.Label>Select Subject</Form.Label>
                        <select id="inputState" class="form-select"
                        onChange={(e) => {
                            setSubject(e.target.value);
                        }}
                        required>
                        <option selected></option>
                        <option>environmental studies</option>
                        <option>english</option>
                        <option>maths</option>
                        </select>
                        <Form.Control.Feedback type="invalid">
                        Please provide a valid Subject.
                        </Form.Control.Feedback>
                    </Form.Group>
                    <Form.Group as={Row} md="2" controlId="validationCustom04">
                        <Form.Label>Select Grade</Form.Label>
                        <select id="inputState" class="form-select"
                        onChange={(e) => {
                            setgrade(e.target.value);
                        }}
                        required>
                        <option selected></option>
                        <option>1</option>
                        <option>2</option>
                        <option>3</option>
                        <option>4</option>
                        <option>5</option>
                        </select>
                        <Form.Control.Feedback type="invalid">
                        Please provide a valid Grade.
                        </Form.Control.Feedback>
                    </Form.Group>
                    </Row>
                    <Button className="btn btn-success" type="submit">Save</Button>
                </Form>
            </Card.Body>
            </Card>
            <br/><br/><br/>
        </div>
    );
}
  
export default StaffRegister;