import React,{useState, useEffect, useContext} from "react";
import axios from "axios";
import { confirm } from "react-confirm-box";
import {BrowserRouter as Router, Link} from 'react-router-dom';
import { useNavigate } from 'react-router-dom';

const deleteQuestion = async (id) => {
    const result1 = await confirm("Are you sure do you want to delete?");
    if (result1) {
       axios.delete(`https://elearning-server.herokuapp.com/question/delete/${id}`).then((res) => {
            alert(res.data.status);
            window.location.reload(false);
        }).catch((err) => {
            alert(err);
        }); 
    }

}

export default function AllStudents(){

    const navigate = useNavigate();

    const [questionArray, setQuestions] = useState([]);

    const [search, setSearch] = useState('');

    useEffect(() => {
        function getQuestions(){
            axios.get("https://elearning-server.herokuapp.com/question/getAll").then((res) => {
                setQuestions(res.data);
            }).catch((err) => {
                alert(err);
            })
        }
        getQuestions();
    }, []);

    function passValues(id, question, option1, option2, option3, answer, subject, grade){
        const edit = {
            id,
            question,
            option1,
            option2,
            option3,
            answer,
            subject,
            grade
        }
        localStorage.setItem('id', id);
        localStorage.setItem('question', question);
        localStorage.setItem('option1', option1);
        localStorage.setItem('option2', option2);
        localStorage.setItem('option3', option3);
        localStorage.setItem('answer', answer);
        localStorage.setItem('subject', subject);
        localStorage.setItem('grade', grade);
        navigate(`/update`);
    }
    

    return(
        <div className="container my-5">
            <div align='left'>
            <Link to="/add">
            <button type="button" class="btn btn-success">
            <svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="currentColor" class="bi bi-clipboard-plus" viewBox="0 0 16 16">
            <path fill-rule="evenodd" d="M8 7a.5.5 0 0 1 .5.5V9H10a.5.5 0 0 1 0 1H8.5v1.5a.5.5 0 0 1-1 0V10H6a.5.5 0 0 1 0-1h1.5V7.5A.5.5 0 0 1 8 7z"/>
            <path d="M4 1.5H3a2 2 0 0 0-2 2V14a2 2 0 0 0 2 2h10a2 2 0 0 0 2-2V3.5a2 2 0 0 0-2-2h-1v1h1a1 1 0 0 1 1 1V14a1 1 0 0 1-1 1H3a1 1 0 0 1-1-1V3.5a1 1 0 0 1 1-1h1v-1z"/>
            <path d="M9.5 1a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-3a.5.5 0 0 1-.5-.5v-1a.5.5 0 0 1 .5-.5h3zm-3-1A1.5 1.5 0 0 0 5 1.5v1A1.5 1.5 0 0 0 6.5 4h3A1.5 1.5 0 0 0 11 2.5v-1A1.5 1.5 0 0 0 9.5 0h-3z"/>
            </svg>
            </button>
            </Link>
            </div>
            <div align='right'>
            <input type="text" class="form-control" placeholder="Search by Question" style={{width:'20rem' }} onChange={(e) => {setSearch(e.target.value)}}/>
            </div>
            <br/>
           <table className="table table-hover">
               <thead>
                   <tr>
                    <th>#</th>
                    <th>Question</th>
                    <th>Option1</th>
                    <th>Option1</th>
                    <th>Option1</th>
                    <th>Answer</th>
                    <th>Subject</th>
                    <th>Grade</th>
                    <th>Edit</th>
                    <th>Delete</th>
                   </tr>
               </thead>
               <tbody>
                   {
                       questionArray.map((val, key) => {
                            return(
                                <>
                                {search ? (
                                    <>
                                    {val.question.toLowerCase().includes(search.toLowerCase()) ? (
                                        <>
                                        <tr key={val._id}>
                                            <td>{key + 1}</td>
                                            <td>{val.question}</td>
                                            <td>{val.option1}</td>
                                            <td>{val.option2}</td>
                                            <td>{val.option3}</td>
                                            <td>{val.answer}</td>
                                            <td>{val.subject}</td>
                                            <td>{val.grade}</td>
                                            <td align="right">
                                                <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                    <button type="button" class="btn btn-outline-primary" style={{opacity: "70%"}} 
                                                    onClick={() => passValues(val._id, val.question, val.option1, val.option2, val.option3, val.answer, val.subject, val.grade)}>
                                                    <svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="currentColor" class="bi bi-pencil-square" viewBox="0 0 16 16">
                                                    <path d="M15.502 1.94a.5.5 0 0 1 0 .706L14.459 3.69l-2-2L13.502.646a.5.5 0 0 1 .707 0l1.293 1.293zm-1.75 2.456-2-2L4.939 9.21a.5.5 0 0 0-.121.196l-.805 2.414a.25.25 0 0 0 .316.316l2.414-.805a.5.5 0 0 0 .196-.12l6.813-6.814z"/>
                                                    <path fill-rule="evenodd" d="M1 13.5A1.5 1.5 0 0 0 2.5 15h11a1.5 1.5 0 0 0 1.5-1.5v-6a.5.5 0 0 0-1 0v6a.5.5 0 0 1-.5.5h-11a.5.5 0 0 1-.5-.5v-11a.5.5 0 0 1 .5-.5H9a.5.5 0 0 0 0-1H2.5A1.5 1.5 0 0 0 1 2.5v11z"/>
                                                    </svg>
                                                    </button>
                                                </div>
                                            </td>
                                            <td align="right">
                                                <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                    <button type="button" class="btn btn-danger" style={{opacity: "70%"}} onClick={() => deleteQuestion(val._id)}>
                                                    <svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="currentColor" class="bi bi-trash3" viewBox="0 0 16 16">
                                                    <path d="M6.5 1h3a.5.5 0 0 1 .5.5v1H6v-1a.5.5 0 0 1 .5-.5ZM11 2.5v-1A1.5 1.5 0 0 0 9.5 0h-3A1.5 1.5 0 0 0 5 1.5v1H2.506a.58.58 0 0 0-.01 0H1.5a.5.5 0 0 0 0 1h.538l.853 10.66A2 2 0 0 0 4.885 16h6.23a2 2 0 0 0 1.994-1.84l.853-10.66h.538a.5.5 0 0 0 0-1h-.995a.59.59 0 0 0-.01 0H11Zm1.958 1-.846 10.58a1 1 0 0 1-.997.92h-6.23a1 1 0 0 1-.997-.92L3.042 3.5h9.916Zm-7.487 1a.5.5 0 0 1 .528.47l.5 8.5a.5.5 0 0 1-.998.06L5 5.03a.5.5 0 0 1 .47-.53Zm5.058 0a.5.5 0 0 1 .47.53l-.5 8.5a.5.5 0 1 1-.998-.06l.5-8.5a.5.5 0 0 1 .528-.47ZM8 4.5a.5.5 0 0 1 .5.5v8.5a.5.5 0 0 1-1 0V5a.5.5 0 0 1 .5-.5Z"/>
                                                    </svg>
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                        </>
                                    ):(
                                        <>
                                        </>
                                    )}
                                    </>
                                ):(
                                    <>
                                    <tr key={val._id}>
                                        <td>{key + 1}</td>
                                        <td>{val.question}</td>
                                        <td>{val.option1}</td>
                                        <td>{val.option2}</td>
                                        <td>{val.option3}</td>
                                        <td>{val.answer}</td>
                                        <td>{val.subject}</td>
                                        <td>{val.grade}</td>
                                        <td align="right">
                                            <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                <button type="button" class="btn btn-outline-primary" style={{opacity: "70%"}} 
                                                onClick={() => passValues(val._id, val.question, val.option1, val.option2, val.option3, val.answer, val.subject, val.grade)}>
                                                <svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="currentColor" class="bi bi-pencil-square" viewBox="0 0 16 16">
                                                <path d="M15.502 1.94a.5.5 0 0 1 0 .706L14.459 3.69l-2-2L13.502.646a.5.5 0 0 1 .707 0l1.293 1.293zm-1.75 2.456-2-2L4.939 9.21a.5.5 0 0 0-.121.196l-.805 2.414a.25.25 0 0 0 .316.316l2.414-.805a.5.5 0 0 0 .196-.12l6.813-6.814z"/>
                                                <path fill-rule="evenodd" d="M1 13.5A1.5 1.5 0 0 0 2.5 15h11a1.5 1.5 0 0 0 1.5-1.5v-6a.5.5 0 0 0-1 0v6a.5.5 0 0 1-.5.5h-11a.5.5 0 0 1-.5-.5v-11a.5.5 0 0 1 .5-.5H9a.5.5 0 0 0 0-1H2.5A1.5 1.5 0 0 0 1 2.5v11z"/>
                                                </svg>
                                                </button>
                                            </div>
                                        </td>
                                        <td align="right">
                                            <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                <button type="button" class="btn btn-danger" style={{opacity: "70%"}} onClick={() => deleteQuestion(val._id)}>
                                                <svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="currentColor" class="bi bi-trash3" viewBox="0 0 16 16">
                                                <path d="M6.5 1h3a.5.5 0 0 1 .5.5v1H6v-1a.5.5 0 0 1 .5-.5ZM11 2.5v-1A1.5 1.5 0 0 0 9.5 0h-3A1.5 1.5 0 0 0 5 1.5v1H2.506a.58.58 0 0 0-.01 0H1.5a.5.5 0 0 0 0 1h.538l.853 10.66A2 2 0 0 0 4.885 16h6.23a2 2 0 0 0 1.994-1.84l.853-10.66h.538a.5.5 0 0 0 0-1h-.995a.59.59 0 0 0-.01 0H11Zm1.958 1-.846 10.58a1 1 0 0 1-.997.92h-6.23a1 1 0 0 1-.997-.92L3.042 3.5h9.916Zm-7.487 1a.5.5 0 0 1 .528.47l.5 8.5a.5.5 0 0 1-.998.06L5 5.03a.5.5 0 0 1 .47-.53Zm5.058 0a.5.5 0 0 1 .47.53l-.5 8.5a.5.5 0 1 1-.998-.06l.5-8.5a.5.5 0 0 1 .528-.47ZM8 4.5a.5.5 0 0 1 .5.5v8.5a.5.5 0 0 1-1 0V5a.5.5 0 0 1 .5-.5Z"/>
                                                </svg>
                                                </button>
                                            </div>
                                        </td>
                                    </tr>
                                    </>
                                )}
                                
                                </>
                            )
                       })
                   }
               </tbody>
           </table>
        </div>
    )

}