import 'react-native-gesture-handler';
import React from 'react';
import { StyleSheet, Text, View } from 'react-native';
import {NavigationContainer} from '@react-navigation/native';
import { createStackNavigator } from '@react-navigation/stack';

import Start from './components/start';
import Exam from './components/exam';
import Subject from './components/subject';
import Result from './components/result';
import Recommendation from './components/recommendation';
import Studentprof from './components/studentprof';
import Login from './components/login';
import Registration from './components/registration';
import Note from './components/Notes';

const Stack = createStackNavigator();

export default function App() {

  return (
    <NavigationContainer>

      <Stack.Navigator>
      <Stack.Screen name="Login" component={Login} options={{title: 'Navigator'}} />
      <Stack.Screen name="Registration" component={Registration} options={{title: 'Navigator'}} />
      <Stack.Screen name="Start" component={Start} options={{title: 'Navigator'}} />
      <Stack.Screen name="Note" component={Note} options={{title: 'Navigator'}} />
      <Stack.Screen name="Exam" component={Exam} options={{title: 'Navigator'}} />
      <Stack.Screen name="Subject" component={Subject} options={{title: 'Navigator'}} />
      <Stack.Screen name="Result" component={Result} options={{title: 'Navigator'}} />
      <Stack.Screen name="Recommendation" component={Recommendation} options={{title: 'Navigator'}} />
      <Stack.Screen name="Studentprof" component={Studentprof} options={{title: 'Navigator'}} />

      </Stack.Navigator>
 
    </NavigationContainer>
  );
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    backgroundColor: '#fff',
    alignItems: 'center',
    justifyContent: 'center',
  },
});
