import { useState, useEffect } from "react";
import {useRoute} from '@react-navigation/native';
import axios from 'axios';
import {
  View,
  Text,
  TextInput,
  StyleSheet,
  Button,
  Pressable,
  TouchableOpacity,
  Alert
} from "react-native";
export default function Notes() {
    const route = useRoute();

    const [level, setLevel] = useState('Loading...');

    const [p1, setp1] = useState(0.0);
    const [p2, setp2] = useState(0.0);
    const [p3, setp3] = useState(0.0);

    const [outputData, setOutputData] = useState([]);


  useEffect(() => {
    // Define the input data

    var eng = false
    var env = false
    var mat = false

    if (route.params.s == 'english'){
        eng = true;
    }
    if (route.params.s == 'environmental studies'){
        env = true;
    }
    if (route.params.s == 'maths'){
        mat = true;
    }

    if (eng || env || mat) {

    const inputData = {
      "input": {
        "0": parseInt(route.params.logged.grade),
        "1": parseInt(route.params.marks),
        "2": parseInt(route.params.time)/60,
        "3": parseInt(route.params.q),
        "4": eng,
        "5": env,
        "6": mat
      }
    };

    axios.post(' https://c5a1-223-224-25-60.ngrok.io/predict', inputData)
      .then(response => {
        const predictions = response.data.predictions;

        if (predictions.length > 0) {
          const [value1, value2, value3] = predictions[0];
          setOutputData([value1, value2, value3]);
          setp1(predictions[0][0]);
          setp2(predictions[0][1]);
          setp3(predictions[0][2]);

          if ((p1 > p2) && (p1 > p3)){
            setLevel('Advance');
          }
          if ((p2 > p1) && (p2 > p3)){
            setLevel('Begginer');
          }
          if ((p3 > p1) && (p3 > p2)){
            setLevel('Intermediate');
          }
        }
      })
      .catch(error => {
        console.error('Error:', error);
      });
    }
    else{
        setLevel('Error')
    }
  }, []);

  return (
    <View style={styles.container}>
      <Text style={styles.header}> Marks : {route.params.marks}</Text>
      <Text style={styles.header}> Time Taken : {route.params.time} s</Text>
      <Text style={styles.header}> Questions : {route.params.q}</Text>
      {outputData.length > 0 ? (
          <>
            <Text style={styles.header}>Level : {level}</Text>
          </>
        ):(
          <>
            
          </>
        )}
    </View>
  );
}
// }

const styles = StyleSheet.create({
container: {
  flex: 1,
  justifyContent: 'center',
  alignItems: 'center'
},
header: {
  fontSize: 32,
  marginBottom: 32
},
input: {
  width: '80%',
  height: 40,
  borderWidth: 1,
  borderRadius: 10,
  paddingLeft: 10,
  marginBottom: 16
},
error: {
  color: 'red',
  marginBottom: 16
},
button: {
  backgroundColor: '#008080',
  padding: 10,
  borderRadius: 5,
  marginTop: 20,
},
button2: {
  color: 'blue',
  padding: 10,
  borderRadius: 5,
  marginTop: 20,
},
buttonText: {
  color: 'white',
  fontSize: 16,
  fontWeight: 'bold'
},
buttonText2: {
  color: 'blue',
  fontSize: 12,
  fontWeight: 'bold'
}
});