import React, {useEffect, useState} from "react";
import { View, Text, TextInput, TouchableOpacity, StyleSheet, Alert } from 'react-native';
import axios from 'axios';

const App = ({navigation}) => {

  const adminMail = 'admin@gmail.com';
  const adminPass = 'admin';
  
  const [email, setemail] = useState([]);
  const [pass, setpass] = useState([]);
  const [emailError, setEmailError] = useState('');
  const [passwordError, setPasswordError] = useState('');


  const login = async () => {
      if (email.length === 0) {
        setEmailError('Please enter your email');
      } else {
        setEmailError('');
      }
      if (pass.length === 0) {
        setPasswordError('Please enter your password');
      } else {
        setPasswordError('');
      }
      if (email.length > 0 && pass.length > 0) {
      try {
      const response = await axios.post(`https://edusense-59f5b618df4b.herokuapp.com/student/log/${email}`, {
        password: pass
      });
      if (response.data.status) {
        navigation.navigate('Start',{
          logged:response.data.details
        });
        Alert.alert('Logged Successfuly');
      }
    } catch (error) {
      console.log(response.data);
    }
}
  };

  const register = async () => {
    navigation.navigate('Registration');
  };

  // render() {
    return (
      <View style={styles.container}>
        <Text style={styles.header}>Login</Text>
        <TextInput
          style={styles.input}
          placeholder="Email"
          onChangeText={setemail}
        />
         <Text style={styles.error}>{emailError}</Text>
        <TextInput
          style={styles.input}
          placeholder="Password"
          onChangeText={setpass}
          secureTextEntry
        />
        <Text style={styles.error}>{passwordError}</Text>
        {/* <Text style={styles.error}>{this.state.passwordError}</Text> */}
        <TouchableOpacity style={styles.button} onPress={() => {login()}}>
          <Text style={styles.buttonText}>Login</Text>
        </TouchableOpacity>
        <TouchableOpacity style={styles.button2} onPress={() => {register()}}>
          <Text style={styles.buttonText2}>Don't you have an account?</Text>
        </TouchableOpacity>
      </View>
    );
}
// }

const styles = StyleSheet.create({
  container: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center'
  },
  header: {
    fontSize: 32,
    marginBottom: 32
  },
  input: {
    width: '80%',
    height: 40,
    borderWidth: 1,
    borderRadius: 10,
    paddingLeft: 10,
    marginBottom: 16
  },
  error: {
    color: 'red',
    marginBottom: 16
  },
  button: {
    backgroundColor: '#008080',
    padding: 10,
    borderRadius: 5,
    marginTop: 20,
  },
  button2: {
    color: 'blue',
    padding: 10,
    borderRadius: 5,
    marginTop: 20,
  },
  buttonText: {
    color: 'white',
    fontSize: 16,
    fontWeight: 'bold'
  },
  buttonText2: {
    color: 'blue',
    fontSize: 12,
    fontWeight: 'bold'
  }
});

export default App;