import React from 'react';
import { View, Text, Button, Dimensions, Image } from 'react-native';

const TutorRecommendation = () => {
  // Sample data
  const tutor = {
    name: 'John Doe',
    subject: 'Mathematics',
    availability: 'Monday - Friday, 9 AM - 5 PM',
    experience: '5 years',
    rating: 4.5,
    profilePicture: 'https://lh3.googleusercontent.com/piy6r1aCtVu9othJeeZbhfE_86HNiroAIyDPMkqmLCfVMr9j0fAlggM4rKicKBplU6VXakaPePgNT6pfZ16P8eaC3a1AEBx_nzEoXo8' 
  };

  // Handle contact action
  const handleContact = () => {
    // Add your contact logic here
    console.log('Contact button pressed');
  };

  return (
    <View style={styles.container}>
      <Text style={styles.title}>Tutor Recommendation</Text>

      <Text style={styles.paragraph}>
        Based on your profile, examination scores, and availability, we recommend the following tutor for you:
      </Text>

      <View style={styles.tutorInfo}>
        <Image source={{ uri: tutor.profilePicture }} style={styles.profilePicture} />

        <View style={styles.fieldContainer}>
          <Text style={styles.fieldTitle}>Tutor's Name:</Text>
          <Text style={[styles.fieldValue, { fontSize: 18 }]}>{tutor.name}</Text>
        </View>

        <View style={styles.fieldContainer}>
          <Text style={styles.fieldTitle}>Subject:</Text>
          <Text style={[styles.fieldValue, { fontSize: 18 }]}>{tutor.subject}</Text>
        </View>

        <View style={styles.fieldContainer}>
          <Text style={styles.fieldTitle}>Availability:</Text>
          <Text style={[styles.fieldValue, { fontSize: 18 }]}>{tutor.availability}</Text>
        </View>

        <View style={styles.fieldContainer}>
          <Text style={styles.fieldTitle}>Experience:</Text>
          <Text style={[styles.fieldValue, { fontSize: 18 }]}>{tutor.experience}</Text>
        </View>

        <View style={styles.fieldContainer}>
          <Text style={styles.fieldTitle}>Rating:</Text>
          <Text style={[styles.fieldValue, { fontSize: 18 }]}>{tutor.rating}</Text>
        </View>
      </View>

      <View style={styles.contactButtonContainer}>
        <Button title="Contact" onPress={handleContact} color="Transparent" />
      </View>

<Image
        source={{ uri: 'https://media.istockphoto.com/id/1181152834/vector/accsessibility-icon-universal-accsess-vector-icon.jpg?s=1024x1024&w=is&k=20&c=8g4ti6Aw-QXhug_dkbDDhBujNiCIWPnATli9NwRG-rg=' }} 
        style={styles.accessibilityIcon}
      />

    </View>
  );
};

const styles = {
  container: {
    flex: 1,
    alignItems: 'center',
    //justifyContent: 'center',
    paddingHorizontal: 20,
    paddingTop: 20,
    backgroundColor: '#f5f5f5',
    marginTop: 40,
    
    
  },
  title: {
    fontSize: 24,
    fontWeight: 'bold',
    marginBottom: 30,
    color: '#333',
  },
  paragraph: {
    marginBottom: 50,
    textAlign: 'center',
    fontSize: 18,
  },
  tutorInfo: {
    alignItems: 'center',
    
  },
  profilePicture: {
    width: 150,
    height: 150,
    borderRadius: 75,
    marginBottom: 25,
  },
  fieldContainer: {
    flexDirection: 'row',
    alignItems: 'center',
    marginBottom: 10,
    
  },
  fieldTitle: {
    fontWeight: 'bold',
    marginRight: 10,
    fontSize: 18,
  },
  

accessibilityIcon: {
    position: 'absolute',
    top: '75%',
    left: -10,
    width: 80,
    height: 80,
    borderRadius: 20,
  },

  fieldValue: {},
  contactButtonContainer: {
    position: 'absolute',
    bottom: 0,
    width: Dimensions.get('window').width,
    paddingHorizontal: 20,
    paddingBottom: 20,
    backgroundColor: '#2714cc',
    height: 80,
    justifyContent: 'center',
    alignItems: 'center',
    //width: '100%',
    paddingVertical: 20, 
    
    
  },
};

export default TutorRecommendation;
