from flask import Flask, request, jsonify
import pickle

app = Flask(__name__)

# Load the pickled model
with open('New_predictor_file.pickle', 'rb') as model_file:
    model = pickle.load(model_file)

@app.route('/predict', methods=['POST'])
def predict():
    data = request.get_json()
    input_data = data['input']  # Assuming you send data as JSON with an 'input' key

    # Convert input_data to a format suitable for prediction
    input_array = [input_data[str(i)] for i in range(7)]

    # Make the prediction
    predictions = model.predict([input_array])

    return jsonify({'predictions': predictions.tolist()})

if __name__ == '__main__':
    app.run(host='0.0.0.0', port=5000)