import React,{useState, useEffect, useContext} from "react";
import axios from "axios";
import { confirm } from "react-confirm-box";
import {BrowserRouter as Router, Link} from 'react-router-dom';
import { useNavigate } from 'react-router-dom';

export default function AllStudents(){

    const navigate = useNavigate();

    const [questionArray, setQuestions] = useState([]);

    const [search, setSearch] = useState('');

    useEffect(() => {
        function getQuestions(){
            axios.get("https://edusense-59f5b618df4b.herokuapp.com/request/getAll").then((res) => {
                setQuestions(res.data);
            }).catch((err) => {
                alert(err);
            })
        }
        getQuestions();
    }, []);

    function accept(id){
        const edit = {
            tutor:"tutortest@gmail.com"
        }
        axios.put(`https://edusense-59f5b618df4b.herokuapp.com/request/accept/${id}`, edit).then((res)=>{
            alert(res.data);
            const mail = {
                s_email:"kavindidile@gmail.com",
                t_email:"tutor@gmail.com",
                name:"Test"
            }
            axios.post(`https://edusense-59f5b618df4b.herokuapp.com/sendmail`, edit).then((res)=>{
                alert(res.data);
                window.location.reload(false);
            }).catch((err)=>{
                alert("Mail address cannot verify");
            })
            
        }).catch((err)=>{
            alert(err);
        })
    }

    function reject(id){
        const edit = {
            tutor:"tutortest@gmail.com"
        }
        axios.put(`https://edusense-59f5b618df4b.herokuapp.com/request/reject/${id}`, edit).then((res)=>{
            alert(res.data);
            window.location.reload(false);
            
        }).catch((err)=>{
            alert(err);
        })
    }
    

    return(
        <div className="container my-5">
            <div align='left'>
            </div>
            <br/>
            <h4>New Requests</h4>
           <table className="table table-hover">
               <thead>
                   <tr>
                    <th>#</th>
                    <th>Subject</th>
                    <th>Level</th>
                    <th>Student</th>
                    <th>Grade</th>
                    <th>Status</th>
                    <th>Accepted by</th>
                   </tr>
               </thead>
               <tbody>
                   {
                       questionArray.map((val, key) => {
                        if(val.status === "New" || val.status === "Rejected"){
                            return(
                                <>
                                {search ? (
                                    <>
                                    {val.question.toLowerCase().includes(search.toLowerCase()) ? (
                                        <>
                                        <tr key={val._id}>
                                            <td>{key + 1}</td>
                                            <td>{val.sub}</td>
                                            <td>{val.level}</td>
                                            <td>{val.email}</td>
                                            <td>{val.grade}</td>
                                            <td>{val.status}</td>
                                            <td>{val.accepted}</td>
                                            <td align="right">
                                                <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                    <button type="button" class="btn btn-outline-success" style={{opacity: "70%"}} 
                                                    onClick={() => accept(val._id)}>
                                                    Accept
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                        </>
                                    ):(
                                        <>
                                        </>
                                    )}
                                    </>
                                ):(
                                    <>
                                        <tr key={val._id}>
                                            <td>{key + 1}</td>
                                            <td>{val.sub}</td>
                                            <td>{val.level}</td>
                                            <td>{val.email}</td>
                                            <td>{val.grade}</td>
                                            <td>{val.status}</td>
                                            <td>{val.accepted}</td>
                                            <td align="right">
                                                <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                <button type="button" class="btn btn-outline-success" style={{opacity: "70%"}} 
                                                    onClick={() => accept(val._id)}>
                                                    Accept
                                                </button>
                                                </div>
                                            </td>
                                        </tr>
                                        </>
                                )}
                                
                                </>
                            )}
                       })
                   }
               </tbody>
           </table>
           <h1></h1> <h1></h1>
           <h4>Accepted Requests</h4>
           <table className="table table-hover">
               <thead>
                   <tr>
                    <th>#</th>
                    <th>Subject</th>
                    <th>Level</th>
                    <th>Student</th>
                    <th>Grade</th>
                    <th>Status</th>
                    <th>Accepted by</th>
                   </tr>
               </thead>
               <tbody>
                   {
                       questionArray.map((val, key) => {
                            if(val.status === "Accepted"){
                            return(
                                <>
                                {search ? (
                                    <>
                                    {val.question.toLowerCase().includes(search.toLowerCase()) ? (
                                        <>
                                        <tr key={val._id}>
                                            <td>{key + 1}</td>
                                            <td>{val.sub}</td>
                                            <td>{val.level}</td>
                                            <td>{val.email}</td>
                                            <td>{val.grade}</td>
                                            <td>{val.status}</td>
                                            <td>{val.accepted}</td>
                                            <td align="right">
                                                <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                    <button type="button" class="btn btn-outline-danger" style={{opacity: "70%"}} 
                                                    onClick={() => reject(val._id)}>
                                                    Reject
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                        </>
                                    ):(
                                        <>
                                        </>
                                    )}
                                    </>
                                ):(
                                    <>
                                        <tr key={val._id}>
                                            <td>{key + 1}</td>
                                            <td>{val.sub}</td>
                                            <td>{val.level}</td>
                                            <td>{val.email}</td>
                                            <td>{val.grade}</td>
                                            <td>{val.status}</td>
                                            <td>{val.accepted}</td>
                                            <td align="right">
                                                <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                <button type="button" class="btn btn-outline-danger" style={{opacity: "70%"}} 
                                                    onClick={() => reject(val._id)}>
                                                    Reject
                                                </button>
                                                </div>
                                            </td>
                                        </tr>
                                        </>
                                )}
                                
                                </>
                            )
                                }
                       })
                   }
               </tbody>
           </table>
           <h1></h1> <h1></h1>
           <h4>Rejected Requests</h4>
           <table className="table table-hover">
               <thead>
                   <tr>
                    <th>#</th>
                    <th>Subject</th>
                    <th>Level</th>
                    <th>Student</th>
                    <th>Grade</th>
                    <th>Status</th>
                    <th>Accepted by</th>
                   </tr>
               </thead>
               <tbody>
                   {
                       questionArray.map((val, key) => {
                            if(val.status === "Rejected"){
                            return(
                                <>
                                {search ? (
                                    <>
                                    {val.question.toLowerCase().includes(search.toLowerCase()) ? (
                                        <>
                                        <tr key={val._id}>
                                            <td>{key + 1}</td>
                                            <td>{val.sub}</td>
                                            <td>{val.level}</td>
                                            <td>{val.email}</td>
                                            <td>{val.grade}</td>
                                            <td>{val.status}</td>
                                            <td>{val.accepted}</td>
                                            <td align="right">
                                                <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                    <button type="button" class="btn btn-outline-success" style={{opacity: "70%"}} 
                                                    onClick={() => accept(val._id)}>
                                                    Accept
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                        </>
                                    ):(
                                        <>
                                        </>
                                    )}
                                    </>
                                ):(
                                    <>
                                        <tr key={val._id}>
                                            <td>{key + 1}</td>
                                            <td>{val.sub}</td>
                                            <td>{val.level}</td>
                                            <td>{val.email}</td>
                                            <td>{val.grade}</td>
                                            <td>{val.status}</td>
                                            <td>{val.accepted}</td>
                                            <td align="right">
                                                <div class="btn-group" role="group" aria-label="Basic outlined example">
                                                <button type="button" class="btn btn-outline-success" style={{opacity: "70%"}} 
                                                    onClick={() => accept(val._id)}>
                                                    Accept
                                                </button>
                                                </div>
                                            </td>
                                        </tr>
                                        </>
                                )}
                                
                                </>
                            )
                                }
                       })
                   }
               </tbody>
           </table>
        </div>
    )

}